# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b236"
os.chdir("/home/simuw/simuw08/nb/sage_notebook/worksheets/wstein/9/cells/0")
sage.server.notebook.interact.SAGE_CELL_ID=0
def strategy(price_series, start, stop, verbose=False):
    buyhold  = []
    strategy = []
    investment = Integer(1)
    if verbose:
       print '%-6s%-10s%-4s%-8s%-10s%8s'%('day','price',
            'sig','strategy ', 'buy&hold', '% change')
    start_price = price_series[start]
    for k in range(start, stop-Integer(1)):
         if price_series[k] >= price_series[k-Integer(1)]:
             signal = -Integer(1)
         else:
             signal = +Integer(1)
         percent_change = price_series[k+Integer(1)]/price_series[k] - Integer(1)
         if verbose:
             print '%-6s%-10.2f%2s  %-3.2f%10.2f%10.2f'%(k, price_series[k],
                   signal, investment, price_series[k]/start_price, percent_change)
         buyhold.append(price_series[k]/start_price)
         strategy.append(investment)
         if signal == Integer(1):  # buy
             investment = investment * (percent_change + Integer(1))
         else: # short
             investment = investment * (Integer(1)/(percent_change + Integer(1)))
    # end for
    show(plot(TimeSeries(buyhold)) +
          plot(TimeSeries(strategy),linestyle='--',rgbcolor='red'))
    return strategy[-Integer(1)], buyhold[-Integer(1)],


# You can add your own symbols (they must be on nasdeq or nyse):
symbols = ['ibm', 'vmw', 'sbux', 'aapl', 'amzn', 'goog',
       'wfmi', 'msft', 'yhoo', 'ebay', 'java', 'rht', ]; symbols.sort()
stocks = dict([(s, finance.Stock(s)) for s in symbols])

@interact
def f(start_days_ago=Integer(20), end_days_ago=Integer(0), table=False, symbol=selector(symbols,buttons=True)):
    start = start_days_ago; end = end_days_ago
    price_series = stocks[symbol].close()
    n = len(price_series)
    if start < end: print "start must be greater than end"; return
    print "** %s **"%symbol.upper()
    print "Starting %s days ago and going until %s days ago"%(start, end)
    print "Solid blue line is buy and hold."
    print "Dashed red line is our contrarian strategy, i.e., buy (long) when the"
    print "price goes down and short when it goes up."
    strat, buy_hold = strategy(price_series, n-start, n-end, table)
    print "STRATEGY: %s   BUY&HOLD: %s"%(strat, buy_hold)

print "e236"
